const bcrypt = require('bcryptjs');
const jwt = require('jsonwebtoken');
const db = require('../app').db;

module.exports = {
  login: (req, res) => {
    res.render('login');
  },

  register: (req, res) => {
    res.render('register');
  },

  loginSubmit: (req, res) => {
    const { email, password } = req.body;

    db.query('SELECT * FROM users WHERE email = ?', [email], (err, result) => {
      if (err) throw err;

      if (result.length > 0) {
        const user = result[0];
        if (bcrypt.compareSync(password, user.password)) {
          req.session.userId = user.user_id;
          req.session.role = user.role;
          return res.redirect('/');
        } else {
          return res.render('login', { error: 'Invalid password' });
        }
      } else {
        return res.render('login', { error: 'User not found' });
      }
    });
  },

  registerSubmit: (req, res) => {
    const { first_name, last_name, phone, email, password, confirm_password } = req.body;
  
    // Check if passwords match
    if (password !== confirm_password) {
      return res.render('register', { error: 'Passwords do not match!' });
    }
  
    // If passwords match, hash the password
    bcrypt.hash(password, 10, (err, hashedPassword) => {
      if (err) throw err;
  
      // Using the userModel to insert the new user
      const userModel = require('../models/userModel');
      userModel.createUser(first_name, last_name, phone, email, hashedPassword, (err, result) => {
        if (err) throw err;
        return res.redirect('/auth/login');
      });
    });
  }

  
  
};
